code	segment	'code'
	assume	cs:code,ds:code

	org	100h

start:	mov	sp,0200h			; move stack pointer
	push	ax

	mov	bx,20h				; resize memory block
	mov	ah,4ah
	int	21h

	mov	word ptr tail+2,cs		; set param block segments
	mov	word ptr fcb1+2,cs
	mov	word ptr fcb2+2,cs

	mov	dx,offset prog			; load program
	mov	bx,offset parm
	mov	ax,4b01h
	int	21h
	jnc	ok				; no error?
term:	ret

ok:	mov	ah,51h				; get relative address
	int	21h
	mov	ax,bx
	add	ax,1cech
	mov	ds,ax
	mov	word ptr ds:[6618h],3980h	; correct size in dwords

	mov	ds,bx				; set segments
	mov	es,bx
	mov	word ptr ds:[0ah],offset term	; set termination address
	mov	word ptr ds:[0ch],cs
	mov	ss,word ptr cs:[parm+10h]	; set stack
	mov	sp,word ptr cs:[parm+0eh]
	pop	ax
	jmp	dword ptr cs:[parm+12h]		; jump to entry point

prog	db	'CW.EXE'			; program filename

parm	dw	0				; default env seg
tail	dd	80h				; command line tail pointer
fcb1	dd	5ch				; first FCB pointer
fcb2	dd	6ch				; second FCB pointer

code	ends

	end	start
